// Package v2 provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.8.2 DO NOT EDIT.
package v2

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"fmt"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/deepmap/oapi-codegen/pkg/runtime"
	"github.com/getkin/kin-openapi/openapi3"
	"github.com/labstack/echo/v4"
)

const (
	BearerScopes = "Bearer.Scopes"
)

// Defines values for AzureUploadOptionsHyperVGeneration.
const (
	AzureUploadOptionsHyperVGenerationV1 AzureUploadOptionsHyperVGeneration = "V1"

	AzureUploadOptionsHyperVGenerationV2 AzureUploadOptionsHyperVGeneration = "V2"
)

// Defines values for BlueprintCustomizationsPartitioningMode.
const (
	BlueprintCustomizationsPartitioningModeAutoLvm BlueprintCustomizationsPartitioningMode = "auto-lvm"

	BlueprintCustomizationsPartitioningModeLvm BlueprintCustomizationsPartitioningMode = "lvm"

	BlueprintCustomizationsPartitioningModeRaw BlueprintCustomizationsPartitioningMode = "raw"
)

// Defines values for ComposeStatusValue.
const (
	ComposeStatusValueFailure ComposeStatusValue = "failure"

	ComposeStatusValuePending ComposeStatusValue = "pending"

	ComposeStatusValueSuccess ComposeStatusValue = "success"
)

// Defines values for CustomizationsPartitioningMode.
const (
	CustomizationsPartitioningModeAutoLvm CustomizationsPartitioningMode = "auto-lvm"

	CustomizationsPartitioningModeLvm CustomizationsPartitioningMode = "lvm"

	CustomizationsPartitioningModeRaw CustomizationsPartitioningMode = "raw"
)

// Defines values for ImageSBOMPipelinePurpose.
const (
	ImageSBOMPipelinePurposeBuildroot ImageSBOMPipelinePurpose = "buildroot"

	ImageSBOMPipelinePurposeImage ImageSBOMPipelinePurpose = "image"
)

// Defines values for ImageSBOMSbomType.
const (
	ImageSBOMSbomTypeSpdx ImageSBOMSbomType = "spdx"
)

// Defines values for ImageStatusValue.
const (
	ImageStatusValueBuilding ImageStatusValue = "building"

	ImageStatusValueFailure ImageStatusValue = "failure"

	ImageStatusValuePending ImageStatusValue = "pending"

	ImageStatusValueRegistering ImageStatusValue = "registering"

	ImageStatusValueSuccess ImageStatusValue = "success"

	ImageStatusValueUploading ImageStatusValue = "uploading"
)

// Defines values for ImageTypes.
const (
	ImageTypesAws ImageTypes = "aws"

	ImageTypesAwsHaRhui ImageTypes = "aws-ha-rhui"

	ImageTypesAwsRhui ImageTypes = "aws-rhui"

	ImageTypesAwsSapRhui ImageTypes = "aws-sap-rhui"

	ImageTypesAzure ImageTypes = "azure"

	ImageTypesAzureEap7Rhui ImageTypes = "azure-eap7-rhui"

	ImageTypesAzureRhui ImageTypes = "azure-rhui"

	ImageTypesAzureSapRhui ImageTypes = "azure-sap-rhui"

	ImageTypesEdgeCommit ImageTypes = "edge-commit"

	ImageTypesEdgeContainer ImageTypes = "edge-container"

	ImageTypesEdgeInstaller ImageTypes = "edge-installer"

	ImageTypesGcp ImageTypes = "gcp"

	ImageTypesGcpRhui ImageTypes = "gcp-rhui"

	ImageTypesGuestImage ImageTypes = "guest-image"

	ImageTypesImageInstaller ImageTypes = "image-installer"

	ImageTypesIotBootableContainer ImageTypes = "iot-bootable-container"

	ImageTypesIotCommit ImageTypes = "iot-commit"

	ImageTypesIotContainer ImageTypes = "iot-container"

	ImageTypesIotInstaller ImageTypes = "iot-installer"

	ImageTypesIotRawImage ImageTypes = "iot-raw-image"

	ImageTypesIotSimplifiedInstaller ImageTypes = "iot-simplified-installer"

	ImageTypesLiveInstaller ImageTypes = "live-installer"

	ImageTypesMinimalRaw ImageTypes = "minimal-raw"

	ImageTypesOci ImageTypes = "oci"

	ImageTypesVsphere ImageTypes = "vsphere"

	ImageTypesVsphereOva ImageTypes = "vsphere-ova"

	ImageTypesWsl ImageTypes = "wsl"
)

// Defines values for UploadStatusValue.
const (
	UploadStatusValueFailure UploadStatusValue = "failure"

	UploadStatusValuePending UploadStatusValue = "pending"

	UploadStatusValueRunning UploadStatusValue = "running"

	UploadStatusValueSuccess UploadStatusValue = "success"
)

// Defines values for UploadTypes.
const (
	UploadTypesAws UploadTypes = "aws"

	UploadTypesAwsS3 UploadTypes = "aws.s3"

	UploadTypesAzure UploadTypes = "azure"

	UploadTypesContainer UploadTypes = "container"

	UploadTypesGcp UploadTypes = "gcp"

	UploadTypesLocal UploadTypes = "local"

	UploadTypesOciObjectstorage UploadTypes = "oci.objectstorage"

	UploadTypesPulpOstree UploadTypes = "pulp.ostree"
)

// AWSEC2CloneCompose defines model for AWSEC2CloneCompose.
type AWSEC2CloneCompose struct {
	Region            string    `json:"region"`
	ShareWithAccounts *[]string `json:"share_with_accounts,omitempty"`
}

// AWSEC2UploadOptions defines model for AWSEC2UploadOptions.
type AWSEC2UploadOptions struct {
	Region            string   `json:"region"`
	ShareWithAccounts []string `json:"share_with_accounts"`
	SnapshotName      *string  `json:"snapshot_name,omitempty"`
}

// AWSEC2UploadStatus defines model for AWSEC2UploadStatus.
type AWSEC2UploadStatus struct {
	Ami    string `json:"ami"`
	Region string `json:"region"`
}

// AWSS3UploadOptions defines model for AWSS3UploadOptions.
type AWSS3UploadOptions struct {
	// If set to false (the default value), a long, obfuscated URL
	// is returned. Its expiration might be sooner than for other upload
	// targets.
	//
	// If set to true, a shorter URL is returned and
	// its expiration is the same as for the other upload targets.
	Public *bool  `json:"public,omitempty"`
	Region string `json:"region"`
}

// AWSS3UploadStatus defines model for AWSS3UploadStatus.
type AWSS3UploadStatus struct {
	Url string `json:"url"`
}

// AzureUploadOptions defines model for AzureUploadOptions.
type AzureUploadOptions struct {
	// Choose the VM Image HyperV generation, different features on Azure are available
	// depending on the HyperV generation.
	HyperVGeneration *AzureUploadOptionsHyperVGeneration `json:"hyper_v_generation,omitempty"`

	// Name of the uploaded image. It must be unique in the given resource group.
	// If name is omitted from the request, a random one based on a UUID is
	// generated.
	ImageName *string `json:"image_name,omitempty"`

	// Location of the provided resource_group, where the image should be uploaded and registered.
	// How to list all locations:
	// https://docs.microsoft.com/en-us/cli/azure/account?view=azure-cli-latest#az_account_list_locations'
	// If the location is not specified, it is deducted from the provided resource_group.
	Location *string `json:"location,omitempty"`

	// Name of the resource group where the image should be uploaded.
	ResourceGroup string `json:"resource_group"`

	// ID of subscription where the image should be uploaded.
	SubscriptionId string `json:"subscription_id"`

	// ID of the tenant where the image should be uploaded.
	// How to find it in the Azure Portal:
	// https://docs.microsoft.com/en-us/azure/active-directory/fundamentals/active-directory-how-to-find-tenant
	TenantId string `json:"tenant_id"`
}

// Choose the VM Image HyperV generation, different features on Azure are available
// depending on the HyperV generation.
type AzureUploadOptionsHyperVGeneration string

// AzureUploadStatus defines model for AzureUploadStatus.
type AzureUploadStatus struct {
	ImageName string `json:"image_name"`
}

// Blueprint defines model for Blueprint.
type Blueprint struct {
	// Container images to embed into the final artfact
	Containers     *[]Container             `json:"containers,omitempty"`
	Customizations *BlueprintCustomizations `json:"customizations,omitempty"`
	Description    *string                  `json:"description,omitempty"`

	// The distribution to use for the compose. If left empty the host
	// distro will be used.
	Distro *string `json:"distro,omitempty"`

	// Package groups to be installed
	Groups *[]PackageGroup `json:"groups,omitempty"`

	// An alias for packages, retained for backwards compatability
	Modules *[]Package `json:"modules,omitempty"`
	Name    string     `json:"name"`

	// Packages to be installed
	Packages *[]Package `json:"packages,omitempty"`

	// A semver version number
	Version *string `json:"version,omitempty"`
}

// BlueprintCustomizations defines model for BlueprintCustomizations.
type BlueprintCustomizations struct {
	Cacerts *CACertsCustomization `json:"cacerts,omitempty"`

	// Directories to create in the final artifact
	Directories *[]Directory `json:"directories,omitempty"`

	// FIDO device onboard configuration
	Fdo *FDO `json:"fdo,omitempty"`

	// Files to create in the final artifact
	Files *[]BlueprintFile `json:"files,omitempty"`

	// List of filesystem mountpoints to create
	Filesystem *[]BlueprintFilesystem `json:"filesystem,omitempty"`

	// Enable FIPS mode
	Fips *bool `json:"fips,omitempty"`

	// Firewalld configuration
	Firewall *BlueprintFirewall `json:"firewall,omitempty"`

	// List of groups to create
	Group *[]Group `json:"group,omitempty"`

	// Configures the hostname
	Hostname *string `json:"hostname,omitempty"`

	// Ignition configuration
	Ignition *Ignition `json:"ignition,omitempty"`

	// Name of the installation device, currently only useful for the edge-simplified-installer type
	InstallationDevice *string    `json:"installation_device,omitempty"`
	Installer          *Installer `json:"installer,omitempty"`
	Kernel             *Kernel    `json:"kernel,omitempty"`

	// Locale configuration
	Locale   *Locale            `json:"locale,omitempty"`
	Openscap *BlueprintOpenSCAP `json:"openscap,omitempty"`

	// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
	// there are one or more mountpoints in which case it will use LVM. 'lvm' always
	// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
	// even when there are one or more mountpoints.
	PartitioningMode *BlueprintCustomizationsPartitioningMode `json:"partitioning_mode,omitempty"`

	// Repositories to write to /etc/yum.repos.d/ in the final image. Note
	// that these are not used at build time.
	Repositories *[]BlueprintRepository `json:"repositories,omitempty"`
	Rhsm         *RHSMCustomization     `json:"rhsm,omitempty"`
	Rpm          *RPMCustomization      `json:"rpm,omitempty"`
	Services     *Services              `json:"services,omitempty"`

	// List of ssh keys
	Sshkey *[]SSHKey `json:"sshkey,omitempty"`

	// Timezone configuration
	Timezone *Timezone `json:"timezone,omitempty"`

	// List of users to create
	User *[]BlueprintUser `json:"user,omitempty"`
}

// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
// there are one or more mountpoints in which case it will use LVM. 'lvm' always
// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
// even when there are one or more mountpoints.
type BlueprintCustomizationsPartitioningMode string

// A custom file to create in the final artifact.
type BlueprintFile struct {
	// Contents of the file as plain text
	Data *string `json:"data,omitempty"`

	// Group of the file as a gid or a group name
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the file in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the file
	Path string `json:"path"`

	// Owner of the file as a uid or a user name
	User *interface{} `json:"user,omitempty"`
}

// BlueprintFilesystem defines model for BlueprintFilesystem.
type BlueprintFilesystem struct {
	// size of the filesystem in bytes
	Minsize    uint64 `json:"minsize"`
	Mountpoint string `json:"mountpoint"`
}

// Firewalld configuration
type BlueprintFirewall struct {
	// List of ports (or port ranges) and protocols to open
	Ports *[]string `json:"ports,omitempty"`

	// Firewalld services to enable or disable
	Services *FirewallServices `json:"services,omitempty"`
	Zones    *[]FirewallZones  `json:"zones,omitempty"`
}

// BlueprintOpenSCAP defines model for BlueprintOpenSCAP.
type BlueprintOpenSCAP struct {
	Datastream    *string                `json:"datastream,omitempty"`
	JsonTailoring *OpenSCAPJSONTailoring `json:"json_tailoring,omitempty"`

	// Puts a specified policy ID in the RHSM facts, so that any instances registered to
	// insights will be automatically connected to the compliance policy in the console.
	PolicyId  *string            `json:"policy_id,omitempty"`
	ProfileId string             `json:"profile_id"`
	Tailoring *OpenSCAPTailoring `json:"tailoring,omitempty"`
}

// BlueprintRepository defines model for BlueprintRepository.
type BlueprintRepository struct {
	Baseurls   *[]string `json:"baseurls,omitempty"`
	Enabled    *bool     `json:"enabled,omitempty"`
	Filename   *string   `json:"filename,omitempty"`
	Gpgcheck   *bool     `json:"gpgcheck,omitempty"`
	Gpgkeys    *[]string `json:"gpgkeys,omitempty"`
	Id         string    `json:"id"`
	Metalink   *string   `json:"metalink,omitempty"`
	Mirrorlist *string   `json:"mirrorlist,omitempty"`

	// Disables modularity filtering for this repository.
	ModuleHotfixes *bool   `json:"module_hotfixes,omitempty"`
	Name           *string `json:"name,omitempty"`
	Priority       *int    `json:"priority,omitempty"`
	RepoGpgcheck   *bool   `json:"repo_gpgcheck,omitempty"`
	Sslverify      *bool   `json:"sslverify,omitempty"`
}

// BlueprintUser defines model for BlueprintUser.
type BlueprintUser struct {
	Description *string `json:"description,omitempty"`

	// Group id to use instead of the default
	Gid *int `json:"gid,omitempty"`

	// A list of additional groups to add the user to
	Groups *[]string `json:"groups,omitempty"`

	// The user's home directory
	Home *string `json:"home,omitempty"`

	// ssh public key
	Key  *string `json:"key,omitempty"`
	Name string  `json:"name"`

	// If the password starts with $6$, $5$, or $2b$ it will be stored as
	// an encrypted password. Otherwise it will be treated as a plain text
	// password.
	Password *string `json:"password,omitempty"`

	// Login shell to use
	Shell *string `json:"shell,omitempty"`

	// User id to use instead of the default
	Uid *int `json:"uid,omitempty"`
}

// CACertsCustomization defines model for CACertsCustomization.
type CACertsCustomization struct {
	PemCerts []string `json:"pem_certs"`
}

// CloneComposeBody defines model for CloneComposeBody.
type CloneComposeBody interface{}

// CloneComposeResponse defines model for CloneComposeResponse.
type CloneComposeResponse struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Id string `json:"id"`
}

// CloneStatus defines model for CloneStatus.
type CloneStatus struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded struct due to allOf(#/components/schemas/UploadStatus)
	UploadStatus `yaml:",inline"`
}

// ComposeId defines model for ComposeId.
type ComposeId struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Id string `json:"id"`
}

// ComposeLogs defines model for ComposeLogs.
type ComposeLogs struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	ImageBuilds []interface{} `json:"image_builds"`
	Koji        *KojiLogs     `json:"koji,omitempty"`
}

// ComposeManifests defines model for ComposeManifests.
type ComposeManifests struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Manifests []interface{} `json:"manifests"`
}

// ComposeMetadata defines model for ComposeMetadata.
type ComposeMetadata struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// ID (hash) of the built commit
	OstreeCommit *string `json:"ostree_commit,omitempty"`

	// Package list including NEVRA
	Packages *[]PackageMetadata `json:"packages,omitempty"`
	Request  *ComposeRequest    `json:"request,omitempty"`
}

// ComposeRequest defines model for ComposeRequest.
type ComposeRequest struct {
	Blueprint      *Blueprint      `json:"blueprint,omitempty"`
	Customizations *Customizations `json:"customizations,omitempty"`
	Distribution   string          `json:"distribution"`
	ImageRequest   *ImageRequest   `json:"image_request,omitempty"`
	ImageRequests  *[]ImageRequest `json:"image_requests,omitempty"`
	Koji           *Koji           `json:"koji,omitempty"`
}

// ComposeSBOMs defines model for ComposeSBOMs.
type ComposeSBOMs struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// The SBOM documents for each image built in the compose.
	Items [][]ImageSBOM `json:"items"`
}

// ComposeStatus defines model for ComposeStatus.
type ComposeStatus struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	ImageStatus   ImageStatus        `json:"image_status"`
	ImageStatuses *[]ImageStatus     `json:"image_statuses,omitempty"`
	KojiStatus    *KojiStatus        `json:"koji_status,omitempty"`
	Status        ComposeStatusValue `json:"status"`
}

// ComposeStatusError defines model for ComposeStatusError.
type ComposeStatusError struct {
	Details *interface{} `json:"details,omitempty"`
	Id      int          `json:"id"`
	Reason  string       `json:"reason"`
}

// ComposeStatusValue defines model for ComposeStatusValue.
type ComposeStatusValue string

// Container defines model for Container.
type Container struct {
	// Name to use for the container from the image
	Name *string `json:"name,omitempty"`

	// Reference to the container to embed
	Source string `json:"source"`

	// Control TLS verifification
	TlsVerify *bool `json:"tls_verify,omitempty"`
}

// ContainerUploadOptions defines model for ContainerUploadOptions.
type ContainerUploadOptions struct {
	// Name for the created container image
	Name *string `json:"name,omitempty"`

	// Tag for the created container image
	Tag *string `json:"tag,omitempty"`
}

// ContainerUploadStatus defines model for ContainerUploadStatus.
type ContainerUploadStatus struct {
	// Digest of the manifest of the uploaded container on the registry
	Digest string `json:"digest"`

	// FQDN of the uploaded image
	Url string `json:"url"`
}

// CustomRepository defines model for CustomRepository.
type CustomRepository struct {
	Baseurl        *[]string `json:"baseurl,omitempty"`
	CheckGpg       *bool     `json:"check_gpg,omitempty"`
	CheckRepoGpg   *bool     `json:"check_repo_gpg,omitempty"`
	Enabled        *bool     `json:"enabled,omitempty"`
	Filename       *string   `json:"filename,omitempty"`
	Gpgkey         *[]string `json:"gpgkey,omitempty"`
	Id             string    `json:"id"`
	Metalink       *string   `json:"metalink,omitempty"`
	Mirrorlist     *string   `json:"mirrorlist,omitempty"`
	ModuleHotfixes *bool     `json:"module_hotfixes,omitempty"`
	Name           *string   `json:"name,omitempty"`
	Priority       *int      `json:"priority,omitempty"`
	SslVerify      *bool     `json:"ssl_verify,omitempty"`
}

// Customizations defines model for Customizations.
type Customizations struct {
	Cacerts    *CACertsCustomization `json:"cacerts,omitempty"`
	Containers *[]Container          `json:"containers,omitempty"`

	// Extra repositories for packages specified in customizations. These
	// repositories will be used to depsolve and retrieve packages. Additionally,
	// these packages will be saved and imported to the `/etc/yum.repos.d/` directory
	// on the image
	CustomRepositories *[]CustomRepository `json:"custom_repositories,omitempty"`
	Directories        *[]Directory        `json:"directories,omitempty"`

	// FIDO device onboard configuration
	Fdo        *FDO          `json:"fdo,omitempty"`
	Files      *[]File       `json:"files,omitempty"`
	Filesystem *[]Filesystem `json:"filesystem,omitempty"`

	// System FIPS mode setup
	Fips *FIPS `json:"fips,omitempty"`

	// Firewalld configuration
	Firewall *FirewallCustomization `json:"firewall,omitempty"`

	// List of groups to create
	Groups *[]Group `json:"groups,omitempty"`

	// Configures the hostname
	Hostname *string `json:"hostname,omitempty"`

	// Ignition configuration
	Ignition *Ignition `json:"ignition,omitempty"`

	// Name of the installation device, currently only useful for the edge-simplified-installer type
	InstallationDevice *string    `json:"installation_device,omitempty"`
	Installer          *Installer `json:"installer,omitempty"`
	Kernel             *Kernel    `json:"kernel,omitempty"`

	// Locale configuration
	Locale   *Locale   `json:"locale,omitempty"`
	Openscap *OpenSCAP `json:"openscap,omitempty"`
	Packages *[]string `json:"packages,omitempty"`

	// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
	// there are one or more mountpoints in which case it will use LVM. 'lvm' always
	// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
	// even when there are one or more mountpoints.
	PartitioningMode *CustomizationsPartitioningMode `json:"partitioning_mode,omitempty"`

	// Extra repositories for packages specified in customizations. These
	// repositories will only be used to depsolve and retrieve packages
	// for the OS itself (they will not be available for the build root or
	// any other part of the build process). The package_sets field for these
	// repositories is ignored.
	PayloadRepositories *[]Repository      `json:"payload_repositories,omitempty"`
	Rhsm                *RHSMCustomization `json:"rhsm,omitempty"`
	Rpm                 *RPMCustomization  `json:"rpm,omitempty"`
	Services            *Services          `json:"services,omitempty"`
	Subscription        *Subscription      `json:"subscription,omitempty"`

	// Timezone configuration
	Timezone *Timezone `json:"timezone,omitempty"`
	Users    *[]User   `json:"users,omitempty"`
}

// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
// there are one or more mountpoints in which case it will use LVM. 'lvm' always
// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
// even when there are one or more mountpoints.
type CustomizationsPartitioningMode string

// DNFPluginConfig defines model for DNFPluginConfig.
type DNFPluginConfig struct {
	Enabled *bool `json:"enabled,omitempty"`
}

// DepsolveRequest defines model for DepsolveRequest.
type DepsolveRequest struct {
	Architecture string        `json:"architecture"`
	Blueprint    Blueprint     `json:"blueprint"`
	Distribution string        `json:"distribution"`
	Repositories *[]Repository `json:"repositories,omitempty"`
}

// DepsolveResponse defines model for DepsolveResponse.
type DepsolveResponse struct {
	// Package list including NEVRA
	Packages []PackageMetadata `json:"packages"`
}

// A custom directory to create in the final artifact.
type Directory struct {
	// Ensure that the parent directories exist
	EnsureParents *bool `json:"ensure_parents,omitempty"`

	// Group of the directory as a group name or a gid
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the directory in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the directory
	Path string `json:"path"`

	// Owner of the directory as a user name or a uid
	User *interface{} `json:"user,omitempty"`
}

// Error defines model for Error.
type Error struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Code        string       `json:"code"`
	Details     *interface{} `json:"details,omitempty"`
	OperationId string       `json:"operation_id"`
	Reason      string       `json:"reason"`
}

// ErrorList defines model for ErrorList.
type ErrorList struct {
	// Embedded struct due to allOf(#/components/schemas/List)
	List `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Items []Error `json:"items"`
}

// FIDO device onboard configuration
type FDO struct {
	DiMfgStringTypeMacIface *string `json:"di_mfg_string_type_mac_iface,omitempty"`
	DiunPubKeyHash          *string `json:"diun_pub_key_hash,omitempty"`
	DiunPubKeyInsecure      *string `json:"diun_pub_key_insecure,omitempty"`
	DiunPubKeyRootCerts     *string `json:"diun_pub_key_root_certs,omitempty"`
	ManufacturingServerUrl  *string `json:"manufacturing_server_url,omitempty"`
}

// System FIPS mode setup
type FIPS struct {
	// Enables the system FIPS mode
	Enabled *bool `json:"enabled,omitempty"`
}

// A custom file to create in the final artifact.
type File struct {
	// Contents of the file as plain text
	Data *string `json:"data,omitempty"`

	// Ensure that the parent directories exist
	EnsureParents *bool `json:"ensure_parents,omitempty"`

	// Group of the file as a gid or a group name
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the file in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the file
	Path string `json:"path"`

	// Owner of the file as a uid or a user name
	User *interface{} `json:"user,omitempty"`
}

// Filesystem defines model for Filesystem.
type Filesystem struct {
	// size of the filesystem in bytes
	MinSize    uint64 `json:"min_size"`
	Mountpoint string `json:"mountpoint"`
}

// Firewalld configuration
type FirewallCustomization struct {
	// List of ports (or port ranges) and protocols to open
	Ports *[]string `json:"ports,omitempty"`

	// Firewalld services to enable or disable
	Services *FirewallServices `json:"services,omitempty"`
}

// Firewalld services to enable or disable
type FirewallServices struct {
	// List of services to disable
	Disabled *[]string `json:"disabled,omitempty"`

	// List of services to enable
	Enabled *[]string `json:"enabled,omitempty"`
}

// Bind a list of network sources to a zone to restrict traffic from
// those sources based on the settings of the zone.
type FirewallZones struct {
	// name of the zone, if left empty the sources will apply to
	// the default zone.
	Name *string `json:"name,omitempty"`

	// List of sources for the zone
	Sources *[]string `json:"sources,omitempty"`
}

// GCPUploadOptions defines model for GCPUploadOptions.
type GCPUploadOptions struct {
	// Name of an existing STANDARD Storage class Bucket.
	Bucket *string `json:"bucket,omitempty"`

	// The name to use for the imported and shared Compute Engine image.
	// The image name must be unique within the GCP project, which is used
	// for the OS image upload and import. If not specified a random
	// 'composer-api-<uuid>' string is used as the image name.
	ImageName *string `json:"image_name,omitempty"`

	// The GCP region where the OS image will be imported to and shared from.
	// The value must be a valid GCP location. See https://cloud.google.com/storage/docs/locations.
	// If not specified, the multi-region location closest to the source
	// (source Storage Bucket location) is chosen automatically.
	Region string `json:"region"`

	// List of valid Google accounts to share the imported Compute Engine image with.
	// Each string must contain a specifier of the account type. Valid formats are:
	//   - 'user:{emailid}': An email address that represents a specific
	//     Google account. For example, 'alice@example.com'.
	//   - 'serviceAccount:{emailid}': An email address that represents a
	//     service account. For example, 'my-other-app@appspot.gserviceaccount.com'.
	//   - 'group:{emailid}': An email address that represents a Google group.
	//     For example, 'admins@example.com'.
	//   - 'domain:{domain}': The G Suite domain (primary) that represents all
	//     the users of that domain. For example, 'google.com' or 'example.com'.
	// If not specified, the imported Compute Engine image is not shared with any
	// account.
	ShareWithAccounts *[]string `json:"share_with_accounts,omitempty"`
}

// GCPUploadStatus defines model for GCPUploadStatus.
type GCPUploadStatus struct {
	ImageName string `json:"image_name"`
	ProjectId string `json:"project_id"`
}

// Group defines model for Group.
type Group struct {
	// Group id of the group to create (optional)
	Gid *int `json:"gid,omitempty"`

	// Name of the group to create
	Name string `json:"name"`
}

// Ignition configuration
type Ignition struct {
	Embedded  *IgnitionEmbedded  `json:"embedded,omitempty"`
	Firstboot *IgnitionFirstboot `json:"firstboot,omitempty"`
}

// IgnitionEmbedded defines model for IgnitionEmbedded.
type IgnitionEmbedded struct {
	Config string `json:"config"`
}

// IgnitionFirstboot defines model for IgnitionFirstboot.
type IgnitionFirstboot struct {
	// Provisioning URL
	Url string `json:"url"`
}

// ImageRequest defines model for ImageRequest.
type ImageRequest struct {
	Architecture string       `json:"architecture"`
	ImageType    ImageTypes   `json:"image_type"`
	Ostree       *OSTree      `json:"ostree,omitempty"`
	Repositories []Repository `json:"repositories"`

	// Size of image, in bytes. When set to 0 the image size is a minimum
	// defined by the image type.
	Size *uint64 `json:"size,omitempty"`

	// Options for a given upload destination.
	// This should really be oneOf but AWSS3UploadOptions is a subset of
	// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
	// are also valid AWSS3UploadOptionas objects which violates the oneOf
	// rules. Therefore, we have to use anyOf here but be aware that it isn't
	// possible to mix and match more schemas together.
	UploadOptions *UploadOptions `json:"upload_options,omitempty"`

	// The type and options for multiple upload targets. Each item defines
	// a separate upload destination with its own options. Multiple
	// different targets as well as multiple targets of the same kind are
	// supported.
	UploadTargets *[]UploadTarget `json:"upload_targets,omitempty"`
}

// ImageSBOM defines model for ImageSBOM.
type ImageSBOM struct {
	// The name of the osbuild pipeline which has the packages described
	// in the SBOM installed.
	PipelineName string `json:"pipeline_name"`

	// The purpose of the pipeline. The `buildroot` pipeline was used for
	// the build environment dueing the image build. The `image` pipeline
	// represents the actual content of the image. Due to the nature of
	// some image types, there may be multiple pipelines of the same
	// purpose.
	PipelinePurpose ImageSBOMPipelinePurpose `json:"pipeline_purpose"`

	// The SBOM document in the 'sbom_type' format.
	Sbom interface{} `json:"sbom"`

	// The type of the SBOM document. Currently only SPDX is supported.
	SbomType ImageSBOMSbomType `json:"sbom_type"`
}

// The purpose of the pipeline. The `buildroot` pipeline was used for
// the build environment dueing the image build. The `image` pipeline
// represents the actual content of the image. Due to the nature of
// some image types, there may be multiple pipelines of the same
// purpose.
type ImageSBOMPipelinePurpose string

// The type of the SBOM document. Currently only SPDX is supported.
type ImageSBOMSbomType string

// ImageStatus defines model for ImageStatus.
type ImageStatus struct {
	Error          *ComposeStatusError `json:"error,omitempty"`
	Status         ImageStatusValue    `json:"status"`
	UploadStatus   *UploadStatus       `json:"upload_status,omitempty"`
	UploadStatuses *[]UploadStatus     `json:"upload_statuses,omitempty"`
}

// ImageStatusValue defines model for ImageStatusValue.
type ImageStatusValue string

// ImageTypes defines model for ImageTypes.
type ImageTypes string

// ImportKeys defines model for ImportKeys.
type ImportKeys struct {
	Files *[]string `json:"files,omitempty"`
}

// Installer defines model for Installer.
type Installer struct {
	SudoNopasswd *[]string `json:"sudo-nopasswd,omitempty"`
	Unattended   *bool     `json:"unattended,omitempty"`
}

// Kernel defines model for Kernel.
type Kernel struct {
	// Appends arguments to the bootloader kernel command line
	Append *string `json:"append,omitempty"`

	// Name of the kernel to use
	Name *string `json:"name,omitempty"`
}

// Koji defines model for Koji.
type Koji struct {
	Name    string `json:"name"`
	Release string `json:"release"`
	Server  string `json:"server"`
	TaskId  int    `json:"task_id"`
	Version string `json:"version"`
}

// KojiLogs defines model for KojiLogs.
type KojiLogs struct {
	Import interface{} `json:"import"`
	Init   interface{} `json:"init"`
}

// KojiStatus defines model for KojiStatus.
type KojiStatus struct {
	BuildId *int `json:"build_id,omitempty"`
}

// List defines model for List.
type List struct {
	Kind  string `json:"kind"`
	Page  int    `json:"page"`
	Size  int    `json:"size"`
	Total int    `json:"total"`
}

// LocalUploadOptions defines model for LocalUploadOptions.
type LocalUploadOptions map[string]interface{}

// LocalUploadStatus defines model for LocalUploadStatus.
type LocalUploadStatus struct {
	ArtifactPath string `json:"artifact_path"`
}

// Locale configuration
type Locale struct {
	// Sets the keyboard layout
	Keyboard *string `json:"keyboard,omitempty"`

	// List of locales to be installed, the first one becomes primary, subsequent ones are secondary
	Languages *[]string `json:"languages,omitempty"`
}

// OCIUploadOptions defines model for OCIUploadOptions.
type OCIUploadOptions map[string]interface{}

// OCIUploadStatus defines model for OCIUploadStatus.
type OCIUploadStatus struct {
	Url string `json:"url"`
}

// OSTree defines model for OSTree.
type OSTree struct {
	// A URL which, if set, is used for fetching content. Implies that `url` is set as well,
	// which will be used for metadata only.
	Contenturl *string `json:"contenturl,omitempty"`

	// Can be either a commit (example: 02604b2da6e954bd34b8b82a835e5a77d2b60ffa), or a branch-like reference (example: rhel/8/x86_64/edge)
	Parent *string `json:"parent,omitempty"`
	Ref    *string `json:"ref,omitempty"`

	// Determines whether a valid subscription manager (candlepin) identity is required to
	// access this repository. Consumer certificates will be used as client certificates when
	// fetching metadata and content.
	Rhsm *bool   `json:"rhsm,omitempty"`
	Url  *string `json:"url,omitempty"`
}

// ObjectReference defines model for ObjectReference.
type ObjectReference struct {
	Href string `json:"href"`
	Id   string `json:"id"`
	Kind string `json:"kind"`
}

// OpenSCAP defines model for OpenSCAP.
type OpenSCAP struct {
	JsonTailoring *OpenSCAPJSONTailoring `json:"json_tailoring,omitempty"`

	// Puts a specified policy ID in the RHSM facts, so that any instances registered to
	// insights will be automatically connected to the compliance policy in the console.
	PolicyId  *string            `json:"policy_id,omitempty"`
	ProfileId string             `json:"profile_id"`
	Tailoring *OpenSCAPTailoring `json:"tailoring,omitempty"`
}

// OpenSCAPJSONTailoring defines model for OpenSCAPJSONTailoring.
type OpenSCAPJSONTailoring struct {
	Filepath  string `json:"filepath"`
	ProfileId string `json:"profile_id"`
}

// OpenSCAPTailoring defines model for OpenSCAPTailoring.
type OpenSCAPTailoring struct {
	Selected   *[]string `json:"selected,omitempty"`
	Unselected *[]string `json:"unselected,omitempty"`
}

// Package defines model for Package.
type Package struct {
	// Name of the package to install. File globbing is supported,
	// eg. 'openssh-*'
	Name string `json:"name"`

	// Optional version of the package to install. If left blank the
	// latest available version will be used. Wildcards are supported
	// eg. '4.11.*'
	Version *string `json:"version,omitempty"`
}

// PackageDetails defines model for PackageDetails.
type PackageDetails struct {
	Arch        string  `json:"arch"`
	Buildtime   *string `json:"buildtime,omitempty"`
	Description *string `json:"description,omitempty"`
	Epoch       *string `json:"epoch,omitempty"`
	License     *string `json:"license,omitempty"`
	Name        string  `json:"name"`
	Release     string  `json:"release"`
	Summary     *string `json:"summary,omitempty"`
	Url         *string `json:"url,omitempty"`
	Version     string  `json:"version"`
}

// PackageGroup defines model for PackageGroup.
type PackageGroup struct {
	// Package group name
	Name string `json:"name"`
}

// PackageMetadata defines model for PackageMetadata.
type PackageMetadata struct {
	Arch string `json:"arch"`

	// Optional package checksum using ALGO:HASH form
	Checksum  *string `json:"checksum,omitempty"`
	Epoch     *string `json:"epoch,omitempty"`
	Name      string  `json:"name"`
	Release   string  `json:"release"`
	Sigmd5    *string `json:"sigmd5,omitempty"`
	Signature *string `json:"signature,omitempty"`
	Type      string  `json:"type"`
	Version   string  `json:"version"`
}

// PulpOSTreeUploadOptions defines model for PulpOSTreeUploadOptions.
type PulpOSTreeUploadOptions struct {
	// Basepath for distributing the repository
	Basepath string `json:"basepath"`

	// Repository to import the ostree commit to
	Repository    *string `json:"repository,omitempty"`
	ServerAddress *string `json:"server_address,omitempty"`
}

// PulpOSTreeUploadStatus defines model for PulpOSTreeUploadStatus.
type PulpOSTreeUploadStatus struct {
	RepoUrl string `json:"repo_url"`
}

// RHSMConfig defines model for RHSMConfig.
type RHSMConfig struct {
	DnfPlugins          *SubManDNFPluginsConfig `json:"dnf_plugins,omitempty"`
	SubscriptionManager *SubManConfig           `json:"subscription_manager,omitempty"`
}

// RHSMCustomization defines model for RHSMCustomization.
type RHSMCustomization struct {
	Config *RHSMConfig `json:"config,omitempty"`
}

// RPMCustomization defines model for RPMCustomization.
type RPMCustomization struct {
	ImportKeys *ImportKeys `json:"import_keys,omitempty"`
}

// Repository configuration.
// At least one of the 'baseurl', 'mirrorlist', 'metalink' properties must
// be specified. If more of them are specified, the order of precedence is
// the same as listed above.
type Repository struct {
	Baseurl  *string `json:"baseurl,omitempty"`
	CheckGpg *bool   `json:"check_gpg,omitempty"`

	// Enables gpg verification of the repository metadata
	CheckRepoGpg *bool `json:"check_repo_gpg,omitempty"`

	// GPG key used to sign packages in this repository.
	Gpgkey     *string `json:"gpgkey,omitempty"`
	IgnoreSsl  *bool   `json:"ignore_ssl,omitempty"`
	Metalink   *string `json:"metalink,omitempty"`
	Mirrorlist *string `json:"mirrorlist,omitempty"`

	// Disables modularity filtering for this repository.
	ModuleHotfixes *bool `json:"module_hotfixes,omitempty"`

	// Naming package sets for a repository assigns it to a specific part
	// (pipeline) of the build process.
	PackageSets *[]string `json:"package_sets,omitempty"`

	// Determines whether a valid subscription is required to access this repository.
	Rhsm *bool `json:"rhsm,omitempty"`
}

// SSHKey defines model for SSHKey.
type SSHKey struct {
	// Adds the key to the user's authorized_keys file
	Key string `json:"key"`

	// User to configure the ssh key for
	User string `json:"user"`
}

// SearchPackagesRequest defines model for SearchPackagesRequest.
type SearchPackagesRequest struct {
	Architecture string `json:"architecture"`
	Distribution string `json:"distribution"`

	// Array of package names to search for. Supports * wildcards for
	// names, but not for versions.
	Packages     []string      `json:"packages"`
	Repositories *[]Repository `json:"repositories,omitempty"`
}

// SearchPackagesResponse defines model for SearchPackagesResponse.
type SearchPackagesResponse struct {
	// Detailed package information from DNF
	Packages []PackageDetails `json:"packages"`
}

// Services defines model for Services.
type Services struct {
	// List of services to disable by default
	Disabled *[]string `json:"disabled,omitempty"`

	// List of services to enable by default
	Enabled *[]string `json:"enabled,omitempty"`

	// List of services to mask by default
	Masked *[]string `json:"masked,omitempty"`
}

// SubManConfig defines model for SubManConfig.
type SubManConfig struct {
	Rhsm      *SubManRHSMConfig      `json:"rhsm,omitempty"`
	Rhsmcertd *SubManRHSMCertdConfig `json:"rhsmcertd,omitempty"`
}

// SubManDNFPluginsConfig defines model for SubManDNFPluginsConfig.
type SubManDNFPluginsConfig struct {
	ProductId           *DNFPluginConfig `json:"product_id,omitempty"`
	SubscriptionManager *DNFPluginConfig `json:"subscription_manager,omitempty"`
}

// SubManRHSMCertdConfig defines model for SubManRHSMCertdConfig.
type SubManRHSMCertdConfig struct {
	AutoRegistration *bool `json:"auto_registration,omitempty"`
}

// SubManRHSMConfig defines model for SubManRHSMConfig.
type SubManRHSMConfig struct {
	ManageRepos *bool `json:"manage_repos,omitempty"`
}

// Subscription defines model for Subscription.
type Subscription struct {
	ActivationKey string `json:"activation_key"`
	BaseUrl       string `json:"base_url"`
	Insights      bool   `json:"insights"`
	Organization  string `json:"organization"`

	// Optional flag to use rhc to register the system, which also always enables Insights.
	Rhc       *bool  `json:"rhc,omitempty"`
	ServerUrl string `json:"server_url"`
}

// Timezone configuration
type Timezone struct {
	// List of ntp servers
	Ntpservers *[]string `json:"ntpservers,omitempty"`

	// Name of the timezone, defaults to UTC
	Timezone *string `json:"timezone,omitempty"`
}

// Options for a given upload destination.
// This should really be oneOf but AWSS3UploadOptions is a subset of
// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
// are also valid AWSS3UploadOptionas objects which violates the oneOf
// rules. Therefore, we have to use anyOf here but be aware that it isn't
// possible to mix and match more schemas together.
type UploadOptions interface{}

// UploadStatus defines model for UploadStatus.
type UploadStatus struct {
	Options interface{}       `json:"options"`
	Status  UploadStatusValue `json:"status"`
	Type    UploadTypes       `json:"type"`
}

// UploadStatusValue defines model for UploadStatusValue.
type UploadStatusValue string

// UploadTarget defines model for UploadTarget.
type UploadTarget struct {
	Type UploadTypes `json:"type"`

	// Options for a given upload destination.
	// This should really be oneOf but AWSS3UploadOptions is a subset of
	// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
	// are also valid AWSS3UploadOptionas objects which violates the oneOf
	// rules. Therefore, we have to use anyOf here but be aware that it isn't
	// possible to mix and match more schemas together.
	UploadOptions UploadOptions `json:"upload_options"`
}

// UploadTypes defines model for UploadTypes.
type UploadTypes string

// User defines model for User.
type User struct {
	Groups *[]string `json:"groups,omitempty"`
	Key    *string   `json:"key,omitempty"`
	Name   string    `json:"name"`

	// If the password starts with $6$, $5$, or $2b$ it will be stored as
	// an encrypted password. Otherwise it will be treated as a plain text
	// password.
	Password *string `json:"password,omitempty"`
}

// Page defines model for page.
type Page string

// Size defines model for size.
type Size string

// PostComposeJSONBody defines parameters for PostCompose.
type PostComposeJSONBody ComposeRequest

// PostCloneComposeJSONBody defines parameters for PostCloneCompose.
type PostCloneComposeJSONBody CloneComposeBody

// PostDepsolveBlueprintJSONBody defines parameters for PostDepsolveBlueprint.
type PostDepsolveBlueprintJSONBody DepsolveRequest

// GetErrorListParams defines parameters for GetErrorList.
type GetErrorListParams struct {
	// Page index
	Page *Page `json:"page,omitempty"`

	// Number of items in each page
	Size *Size `json:"size,omitempty"`
}

// PostSearchPackagesJSONBody defines parameters for PostSearchPackages.
type PostSearchPackagesJSONBody SearchPackagesRequest

// PostComposeJSONRequestBody defines body for PostCompose for application/json ContentType.
type PostComposeJSONRequestBody PostComposeJSONBody

// PostCloneComposeJSONRequestBody defines body for PostCloneCompose for application/json ContentType.
type PostCloneComposeJSONRequestBody PostCloneComposeJSONBody

// PostDepsolveBlueprintJSONRequestBody defines body for PostDepsolveBlueprint for application/json ContentType.
type PostDepsolveBlueprintJSONRequestBody PostDepsolveBlueprintJSONBody

// PostSearchPackagesJSONRequestBody defines body for PostSearchPackages for application/json ContentType.
type PostSearchPackagesJSONRequestBody PostSearchPackagesJSONBody

// ServerInterface represents all server handlers.
type ServerInterface interface {
	// The status of a cloned compose
	// (GET /clones/{id})
	GetCloneStatus(ctx echo.Context, id string) error
	// Create compose
	// (POST /compose)
	PostCompose(ctx echo.Context) error
	// The status of a compose
	// (GET /composes/{id})
	GetComposeStatus(ctx echo.Context, id string) error
	// Clone an existing compose
	// (POST /composes/{id}/clone)
	PostCloneCompose(ctx echo.Context, id string) error
	// Get logs for a compose.
	// (GET /composes/{id}/logs)
	GetComposeLogs(ctx echo.Context, id string) error
	// Get the manifests for a compose.
	// (GET /composes/{id}/manifests)
	GetComposeManifests(ctx echo.Context, id string) error
	// Get the metadata for a compose.
	// (GET /composes/{id}/metadata)
	GetComposeMetadata(ctx echo.Context, id string) error
	// Get the SBOMs for a compose.
	// (GET /composes/{id}/sboms)
	GetComposeSBOMs(ctx echo.Context, id string) error
	// Depsolve one or more blueprints
	// (POST /depsolve/blueprint)
	PostDepsolveBlueprint(ctx echo.Context) error
	// Get a list of all possible errors
	// (GET /errors)
	GetErrorList(ctx echo.Context, params GetErrorListParams) error
	// Get error description
	// (GET /errors/{id})
	GetError(ctx echo.Context, id string) error
	// Get the openapi spec in json format
	// (GET /openapi)
	GetOpenapi(ctx echo.Context) error
	// Search for detailed information on a list of package names
	// (POST /search/packages)
	PostSearchPackages(ctx echo.Context) error
}

// ServerInterfaceWrapper converts echo contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler ServerInterface
}

// GetCloneStatus converts echo context to params.
func (w *ServerInterfaceWrapper) GetCloneStatus(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetCloneStatus(ctx, id)
	return err
}

// PostCompose converts echo context to params.
func (w *ServerInterfaceWrapper) PostCompose(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostCompose(ctx)
	return err
}

// GetComposeStatus converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeStatus(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeStatus(ctx, id)
	return err
}

// PostCloneCompose converts echo context to params.
func (w *ServerInterfaceWrapper) PostCloneCompose(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostCloneCompose(ctx, id)
	return err
}

// GetComposeLogs converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeLogs(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeLogs(ctx, id)
	return err
}

// GetComposeManifests converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeManifests(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeManifests(ctx, id)
	return err
}

// GetComposeMetadata converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeMetadata(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeMetadata(ctx, id)
	return err
}

// GetComposeSBOMs converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeSBOMs(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeSBOMs(ctx, id)
	return err
}

// PostDepsolveBlueprint converts echo context to params.
func (w *ServerInterfaceWrapper) PostDepsolveBlueprint(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostDepsolveBlueprint(ctx)
	return err
}

// GetErrorList converts echo context to params.
func (w *ServerInterfaceWrapper) GetErrorList(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Parameter object where we will unmarshal all parameters from the context
	var params GetErrorListParams
	// ------------- Optional query parameter "page" -------------

	err = runtime.BindQueryParameter("form", true, false, "page", ctx.QueryParams(), &params.Page)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter page: %s", err))
	}

	// ------------- Optional query parameter "size" -------------

	err = runtime.BindQueryParameter("form", true, false, "size", ctx.QueryParams(), &params.Size)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter size: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetErrorList(ctx, params)
	return err
}

// GetError converts echo context to params.
func (w *ServerInterfaceWrapper) GetError(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetError(ctx, id)
	return err
}

// GetOpenapi converts echo context to params.
func (w *ServerInterfaceWrapper) GetOpenapi(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetOpenapi(ctx)
	return err
}

// PostSearchPackages converts echo context to params.
func (w *ServerInterfaceWrapper) PostSearchPackages(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostSearchPackages(ctx)
	return err
}

// This is a simple interface which specifies echo.Route addition functions which
// are present on both echo.Echo and echo.Group, since we want to allow using
// either of them for path registration
type EchoRouter interface {
	CONNECT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	DELETE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	GET(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	HEAD(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	OPTIONS(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PATCH(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	POST(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PUT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	TRACE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
}

// RegisterHandlers adds each server route to the EchoRouter.
func RegisterHandlers(router EchoRouter, si ServerInterface) {
	RegisterHandlersWithBaseURL(router, si, "")
}

// Registers handlers, and prepends BaseURL to the paths, so that the paths
// can be served under a prefix.
func RegisterHandlersWithBaseURL(router EchoRouter, si ServerInterface, baseURL string) {

	wrapper := ServerInterfaceWrapper{
		Handler: si,
	}

	router.GET(baseURL+"/clones/:id", wrapper.GetCloneStatus)
	router.POST(baseURL+"/compose", wrapper.PostCompose)
	router.GET(baseURL+"/composes/:id", wrapper.GetComposeStatus)
	router.POST(baseURL+"/composes/:id/clone", wrapper.PostCloneCompose)
	router.GET(baseURL+"/composes/:id/logs", wrapper.GetComposeLogs)
	router.GET(baseURL+"/composes/:id/manifests", wrapper.GetComposeManifests)
	router.GET(baseURL+"/composes/:id/metadata", wrapper.GetComposeMetadata)
	router.GET(baseURL+"/composes/:id/sboms", wrapper.GetComposeSBOMs)
	router.POST(baseURL+"/depsolve/blueprint", wrapper.PostDepsolveBlueprint)
	router.GET(baseURL+"/errors", wrapper.GetErrorList)
	router.GET(baseURL+"/errors/:id", wrapper.GetError)
	router.GET(baseURL+"/openapi", wrapper.GetOpenapi)
	router.POST(baseURL+"/search/packages", wrapper.PostSearchPackages)

}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+x9eXMaO7b4V1HxS1VuXtgXg111ax7GG7bxBrZjDymP6BYg0y21JTUY35fv/ist3XRD",
	"s8XJvXNn8sfMjWktR0c6R2fXHymLuh4liAie2vsj5UEGXSQQM38NkPyvjbjFsCcwJam91BUcIICJjV5T",
	"6RR6ha7noFjzMXR8lNpLFVLfvqVTWPZ58RGbptIpAl35RbVMp7g1RC6UXcTUk79zwTAZqG4cvyXMfeG7",
	"PcQA7QMskMsBJgBBawjMgFFoggFCaPL5pfCotqvg+RZ8VEPX79uHjWLDoQQ1JPq4mgjaNpZgQueKUQ8x",
	"gSUgfehwlE55kZ/+SDE0UOtZmCid4kPI0NMEi+ETtCzqm40xK0vt/TNVKJbKlZ1qbTdfKKa+plMKE4lj",
	"mR8gY3Cq1s7Qi48ZsuUwBoavYTPae0aWkP30+m49h0L7UqGef/cCQ8BTyM9MEBeZQir9Zy47neIEenxI",
	"xZPe7ShM7jQTfF2EKhlhybCuQ2NbQOFrKokhCro4DhF0cSZv1Ur56m6pWq1Udit2uZeEsS1RPLcYOW96",
	"zRlol95zBDy/52BLk3Af+o4I28VJutkHHAkgKFCfwW9iiIDpAhTxfkoDCBxKBmlAe32fW1AgG9zenHcJ",
	"5oAh4TOC7CxoCg7Qq4cZlEMDFw+GAvQQ4JQSxIAYQgL6lAEqhogBX62tSwRkAyR4tku6ZAaLYD6S0/Ih",
	"ZQIxORuITAYgsbsExyfEHEjYOXQRgFxNJf+OTgdms822qEepgyB5/6Zutp3LjqLPnGRWHJ1CNkoc/81n",
	"6D3HZTj1EHsaPw0QQRqfsaOTupPLj5+cxpBSjhSO71qg6cp76UQOcwdmo6SBjft9xBARoI+g8BnigBKg",
	"AAZQ/m8MsQN7DuoSG3mI2JgMZAs57sJweuMQ8V2JDQXUXTGCkRl9YglPyHLmrjF5RGhfTaEPBrKB6iBP",
	"MXB9rg6uT/CLL+9a1XCAx4gAhjj1mYXAgFHfy6ozKyeRp4+6WEjS6DPqqi5y5xAX8iAzSGzqAkoQ6EGO",
	"bLlCCG5vmwcA8y4xK0S2WWCUQyrAkliQQ63ITkUXeG6+BIv0GB1jucgA/CcFfhpMhojpLVSzSHrzHVst",
	"PsALJLLbAHOBmILvhE4kiTqYCwAdBwRg8L0uGQrh8b1czqYWz7rYYpTTvsha1M0hkvF5znJwDsq9zxne",
	"/Y8xRpPf1U8Zy8EZBwrExf+DbwFzf5ITPYWTfFQolxAHP0nUEyoA95CF+xjZaYCF/NFGtm/FNmQJHuaR",
	"Lukd+ZI+kjl/tO/q0xU/Lhugex6UDvUtSG7MMMdqxqT72++FIDxhexGo5oEEKdrsO4Apo4pd6xWtDOwV",
	"y5lyuVDK7OatSmanUCzld1Atv4uKSdAJRCARK+CSQOhGm0FljmAfE1vttaZQzVOuKBPQ2eQsBudQ4DHK",
	"2JghS1A2zfV9YkMXEQEdvvA1M6STjKAZOXVGgzyHpIpVRf1KbydTsEr9TNmG+QzcKRYz+V5+J18s7dpV",
	"u7r2KplhbHFvF07gmgth2YUT55CbsJw5ICMDJIGw7/jIY5iILa8iixIBMTFK0NydE3zTp4PLU4DcnmTf",
	"RIoNQyQPBXQAZKIPLSlVhoLqB4b6qb3U/8vNdK6c0Spy4bhJAqzlc0Fd/AbDi3XVUOGyG/Fu3+buzwTJ",
	"2cZcMLq46o4UyeQ33PMV6QoKfI5CEcfSWlAWNPvAQX0BkOuJqfo0pFx0iR4YTLDjKErii7TdRzZlMFPa",
	"TSJgdc54ki5qjSSR6u8SrJ68L7mAjoPsTZFvRtHMLQH/LrV9o1XGp68TAB1sZD1Pj8LTUkqUe2mrn3vQ",
	"Gk0gs7nCEhSwhx0spmr120CXBFhAOwv4CmBZirH34ioJmjFiPFEaqAOO3DFiwLQARKnxse2vZqvZan4t",
	"ya8n9sYCsWxD+tBCTKyn1npDNotNpelHc2mchPmD2UeJfIshKELhLmQaeBuuEQw5TdqOvk3X9T86uFQt",
	"ceLpPpI//yhQw/2RoyaCK2ebcoHcBHFSinq0D2ZtgCtFM49iIiIgfhcwZtJEkJJ4ziGRygI4al61gUtt",
	"lKjI9TFDE+g4W0BiOgTcbjkWZsxuu1Uv5W+SRycrKg1K+nigdKaAmauGSfrOgODgYlkFRTNop2xxivso",
	"+nmy0Rhba5SlaAegO6SB5TOp3jlTQIkzlZdL33fCuwnZA5Th2PUcJZtnAo7HgFzC3CWUs9E4x22YuMCg",
	"49oVhg2/pVMjxAhaewzOdCujUzloXftz3epbOkU9RLgFvY0P2qWHSLtRv9LXBBNqMzAZPKmzHNO5oS9o",
	"xhm7C5p3GznIEmAopWAtGoyMtBzc8OHIyM6Cj8FAH/V3KTowOAE+cRDnXSKUyC11cameUgZcylCMwrHU",
	"FrA1BBbkSErc4Tjnd60s+KjGhs4ETnmX+Bxx+XsaIKkxT4ZIMS4zBaEAvQoGo+NnwUcGJx+B6ikhC8Hn",
	"XZI0yBI449YBBiepdErjL0Tl10SFzqMcL7s3biJfJdFPGBZI/iOHhJWb+m5W9c/auTiHNvaECyqQRDEU",
	"8hsPkCCUEAagAD0fOzYQ2EXZzYWS8DiF0CXeQWzI3XVD3Zy0Wws3KfPW97ta7MYRkzxhLfjtoJ3sw4cj",
	"NF3ObjkfghGa8k1R026fnKFEbEgcv1Gylro7Qbtv6ZTPNcNJhk1+fc/9d8uTNI5vq+QrdX8niHhaSVFX",
	"9DqZQZ+zuORlQwGT1S0JecD/1eiQA8+BcmT0KpZqC4uDqftvfiQIBtiWtAyNicTcb7M7gVHlHKAEXfZT",
	"e/9clLbDXzARaCAR+lUrDUnOM8RczKUQzIEeILyoFESYAGoJqK4vF4oYIPmdcjlpuR4UwyRBXwxBqJI6",
	"8TUp1uFOze8LIyYfussJ0b63OP78AH+y1w9C35zUr1b4dd2pnEmP8aPlYpLsTZS/RtdjREtMQG8qEI8u",
	"o1goV8u10k65lk69ZgY0Y0DxMRE7Za0kBtdA3JqRG0O2Vq2JdE6H8K5Z8EzAXKngzMv0upsNLCPaad65",
	"4L2hRg1K5jvqM/hNar2UCcAgGSD+SZlqPUYFtaij2JKUTqJo/GeqWNwTlpdKp2p58w/sQk/9czun3oac",
	"PlhwlONL3qotUJswy2CER9VrO2YZClsLh1LyOy4Ygm7icp85JU8CYoeqX9aAGExz2r686ISdJGugDram",
	"iYbPK19I6g2N1kC3Bc2DgGnLixlIfs3TgEtGAgWAZKqFcGJJUSk0ywNBu0Se28FQ8FAKlFKPCwW2oONM",
	"5YkjSNnDDVuSK3GwHCqY3MxsUcKpY+QRwwn3Ur6vjI+L/I9RSb1mlYsnZ1ssRjA4z4dmM60kzohQtLDx",
	"PciRz5z4+Zuxi8BobNkky5A9hNpgbOmLMGdjLnJsiJxarpZ7re087ZRzckTKc5TnYthiONEUPkdHSGmz",
	"UczFtFgHLbUxDbyBNUTWKLnrwBsooSm6yrXALNlBFwnoYDJKxpSLGaOMZ7UB0WNUbkeWskEu6PcPKSD/",
	"HhgYi10/ny/uQGYNf9cY3ABtehIHc7EIRAiD/Jy1EBGUq/n/wZCDIEe/1zKa1CMzQ/n/O2X9i4JvH3J0",
	"2d4EFmWOfBpS0cevyZYmLjeVA9USMiym8n4TKCJvKGd2cEqXuaOX2xcZpnLYyMfw9tb6zNPq48G5M0YM",
	"96dJn+fN/Guo7dZIK1vY+dYZwgdJHFPLj9gOrN+SDyJoBxJEoDenEzCyzH5d115M2gcz4CP2HWjb2kcs",
	"JStBo+L97Aiq5oVNaH1Ik2w8HTPBRw5kAxC6mpKGTNSUpIakwz2kohST/jgfZpBdrFQKu6Ber9cbpYs3",
	"2Cg4jwfNwkXnsCJ/a16w47ND1nrAn1ut24l/Am/qp+7NOW2+3fSLLwdF+6Dylt/vvOZ2XpNgWvQgyeUU",
	"kkVlzieUJfkBjaPaNABcQKZuMjEEH3Y+pMGHyoe0lHM/FHsfQgtEDwEuqLz/IO8SSAAiFpt68o4LRsqC",
	"SzFEbIIjhoseAkLpR7YWoWfqTJeE/aI0GQ2UQlrom3e4DzAB6qM5nolyfdKxluTzPad6U8t8orF8y1gi",
	"5D6FhvmIMJnJZPYPj5sXoHF402keNRv1zmEmk+l2SavZbOQPGo16Dw/qk+Z+fdC8bWaz2W6XZDKZw4uD",
	"uS7vCKSbAZe4+kiU4D61FfXMdKFV4khClKFSLKO/3CDuUWLiDx1ng1EvFWQ3SIXEWEjpX3NuWTtOTIVi",
	"CZUrO9UMqu32MoWiXcrAcmUnUy7u7FQq5XI+n8+vF9M24enh6mYe4+9f1Kr2Mb+0nlbjs2n/B2FSL+mc",
	"DvgPXZRyuiujYaJ0Z0CIq8mSabA+tNAf35IuphF9xmtN5PQZq7UkRwEYgFaiogUJ7iMufig+3Oig70fG",
	"vGEgHH31ypCAgQXtRy2MSpkVPVnUdbFIDJz5bQj58FNwU8gdEMA0T3+HT1rLQphYjq9i8C4O727qW/ql",
	"Q0QkGaN1NNz6UAzDWnXrBAU/gvib2Zgr7zNChY6Lnm3tXFRHOtUL41W+fpu/AXvRWJaNTLvbB44kxItE",
	"Yj7irEyqoJlaamnc44a4VkGbIabnOm9uopkf5nv5ywL5xRAQ2fb2/mXrx3LVYJmLsrmcC9jU8l1lCZfq",
	"m8p50A43TXWh3UTH4USJZqMBZ/Glxmt0OJvB574y3wyViCuAVGkFEBOqBuJp5QwLBtHOJETGmFEix1c2",
	"wUiLLoGW8KEDjEUj9OyqeTeldrXhcvpEN8sqhqqHX8lMf4T0kXRn8nDc9Uszokk61hVtSRGzUZIIYkN4",
	"JF3MBtqsTwyRdyoBZ34fzEDxBW6yL4eMUZZgT0UCYmVVm7cjxQwTkCdq/IsyVdh4AQC9HskNjZ+X+5aF",
	"uFxLH2LHZ1L1MnHkckERZThsuMA1Z/F/CytbEUK+EIYXBCeGAcdLY7d1AGeSt9kc45mRNhg0CHWMu3eU",
	"CZhNs+YnZa1Us+4JOEi0Sjj8aWb7WfT3MeqAznkbqDa4j63AQxFOqpIz1lmNzAITdbJgSe9JWFixLeF+",
	"GB3figeNzsWcUK6YZiKq4CCBhcPBljPokPZETWIdbiK8cAvrGh6Yu3/eLil/Dzh+INouJELMFmOyMIIz",
	"lmwRMXkrc36u64OL5AyLOdy8+HCaxTTnTk24f87sx94KrM1nxKSDJSeeNiVWbeAS+DfxCCir7dPAGyRb",
	"bvXnwMSb3OZdTgVjYvzlNfjpXoMfZvDn3Hl6rzn/r4zbjUf8/6iA/afVcV2HKgot2iYWRh7xzGIC4ppc",
	"FnSGiKMuifWORtfLy9pGHqfOGJkMKsEwGqNw/Cyoh/h1pmkVhcdnn2f2bTg2SVjY9SiLuG//tRCA9q+Z",
	"86BLDPOeMd3N8DrPLRPQOxdm/ZeESm8YOrBJrPPGQ62PVF45QvOqvU1ochD3sEAty5xZ/1bxydF0ol9h",
	"y3/bsOV4tPLMgBhxAnmUiwFDfLv4oV+hz/8Woc8enErh/C+5KhXZbXxfdklAmpdtgAVHTl/VKpjqwQhV",
	"KdthMvmcRYxRKgBlXQLJ1FQEkIiO2s5V6JyFOP+kYA4mfuJIcNDHyLGDMReWgznAA0JZkFW3Ebv9D4jc",
	"jiSmru0XbfuOWOzNL//NY6sPLo6uHH+Aib7OFhXEFfpU4njmIG/qnJgrScKsIRbIEj6bC6sI9Z4FMv4+",
	"98T3uBfmGcW7j/qcdjJbyRx86ThivsbwPPPCzwUu/LU+r4UwagNNkv41E5CXB/eH0v33RPgjwn2GnjzI",
	"gmpTqwvDHKr2IMhcAbojiAj/AL3iqIUmGn64QQrAbDU6DyAM/zfpANj+S/IAZmCtTAaoVirflwwQje9a",
	"yAiwMfvOhIA5bIbJACY34Ecgc9OsgNBF8KP8N5bZw8WE+ajXQfaAkQIYCbxrM/eDpbNKTfO5gZNdJGrJ",
	"58bQtNmyVesVnsiNWJBG9XucblKx3jKHoXlwabQoQEmPQrYum8HGT25/8KTR/SSBeHKh9SRZ1ZJ9xT55",
	"8vze0whNn4aQD9e3woQjy1yZq1vKsz8LZ1s01EHiSx7qK2ClXITY09LiTAuHX6n52yG0rfNewoxmwJFQ",
	"ZV6WSiHrOLcOP1bVsObGTqU3EmH+BllmP/E+W+Pp+pXh9t+T4bYmse3p75bZ9rQ0tS3Z3vgrvW3L9LZv",
	"K1Dbjoz6XVgNwFKxALoOBmXA1vkmCdcuj9wYibnVkfFmo0TwKZBDkNgOd7F7at2sunF80r6QG0eEt2VU",
	"+FK8PwYJh1sgfR8TG8AwP4QgMaFsBHRYg84OAW+UqGuQIQmVJYBgsN/Hlor/6BIxpByFPcKyf+paRkJg",
	"MgivPDlS0oWZbHYnEdu27JkGeKHwUzCtso5Bz3OmKkcwWt1zNumS8JQVJBoMH9wtykazNOyt6+fzJUv3",
	"Uf9G/8zp31zIR/qXr/+nf2nVG/qH/8MeR2JP/6r+rX9f70RPOgvHjav3hJv0fGuExHI3AyRaepD3bbtT",
	"vzio3xyAtqAMDhCwHMg52FdDZOfLO5o/MmaGLUtZdoZIq3lzsUihs1AyTVUx1wYN6nq+QOCQDDAJQv66",
	"pBPW2lMDzVW/nGAxNPLdceMKGE992hjFMVfm27hxVoct6oKrM8elqk4Wq9MYlsXsko8mdJJloIczest9",
	"H9t6xz8GkoyZTooFIgb1NmUzZ0VeF1Epl6i/RwoRhmsKXAxRT2wEv5LqDT5V4dwQlVD+jW01elC1Mgva",
	"CIEwuMShvp0dUDowIVxcHx1VvDAXFr809UbjxS5VMI/vCJwxkIeFMS2HcsRFIKQZ+iO/mZqUwfHUBzPs",
	"9kmi2ZK8i8QziOeRjPwtSkknsxGDF7VuEDSX8KpR4ic56fiq45ntEhUvaw6JwroJKYhkWIeCpZlGOfKy",
	"4E5BoIVhDiBDe10CQAZ8lMLm3h/IhdjB9rePe6BOgPoLQNtmiHOtSjDkMcSV+hLOZckhwNyysuCIMmCw",
	"lwYfoYMt9L+RsL2PWTOzuR/rut+WMOipzRDL5nanGeUEyUDP+1/oedyjIjswnYI+UZCU5rItNsz6gxKr",
	"Eq45FNguJjwRBzZ1ISZ7f+j/ygkVeYK2jwUC+lfwm8ewC9n00+LkjqMnDNI3zU0Lhek7j5EZ6X2UItXH",
	"OZiSqW710QzK0mrmoDIZIZl2SYDf7pzsqg7cwqlIhcJocB423byU0VP3FtGcSqcMgqM//pRi9uG9++PK",
	"kKq7WY7/NJ/hBbmFiA2JyPQYxHamlC9VCqW1SlJkuPS6qqbHgeq/hfCwOp3ZsCVtHJgZVX6jnh7+U2JK",
	"8/rK1nMDfn9tx2YkRmMLCTrotkYXVDHNttYXNokAOQza61gaLnqUik07H4UdEoXEhTm2rlxr/IfrDMyq",
	"3SpcH0VXtgUIidG4V4yOMdfBFuD25nyjoNpE6KKJPj/fralJUf+8Qb5FZ+ppx7ROnVsb29LuyFY/w6kZ",
	"fT/F2CTzC1ZfYyNSi0yHtqEsuB8iEryDkI9WwpYdsLxYXUyw67tdYqO+KnTbm0baKbkmfrmUi7vl3Z1q",
	"cXdnmZFJi+tP1NsoVS2uSc26m+cVkmVrOadOR9L9lK6iBFfPQfMPNJgMKIFcoBfJuwQCjjzIJHM0rW0k",
	"NS4t7KoLFgsO6IQEU2RBy4zfJbN3CMwcUouYIKkd8xkYwTfDQ9VjEiNlCmCoS7jv6Rt/izgPjauOGnft",
	"RRqjkhgBzJ3SrwE1qiysRcc39pCDyVqt0SzTxNyDoJvR7oZGzwoDffQoPanwGZ1QJbOFVYyziZd1AIvn",
	"s+CxnkVwzMfwxQLTScfi/EuBxygV/4rACI022KdMGzYWs99sH0meNyMO1cQMqn6ZDaiCegIBUisKyzPl",
	"wIEfpugQ9awFoP0u4dSNkiFPm8gtF6pQp/CYBXPGDlqXGCRkI6Fc4cqD45AYx8V71N0g2zDw1HyU7dW5",
	"+mhUn8jObZI0HfZfQepmZTEAsqARD7tsXx18kUxtRlmRtXPPfk1Y7nymUU9LySFI6bnjn3AEZ+SzRCpF",
	"gQ974zy70BW7dZ6hydALuehmA8SLKMx13uIemx9nJX8K8gTj6NsqJS+tj7T+pwZa/zuoZmby9hbOeOSO",
	"j0wFJ3IaOOGZIcywoY/NX5F/cuiFf75pYPR7Iwh61diX+B+RfiocOMytN38FGQjmh1mkbzo1UL6HgRUO",
	"MJAiU6jQqP/GOmAqMlLcgz0nPrT8EE6s/4h/nB+FwclsHioSg5hT6ZSDx3EIlFABnYyOHaWWhHrMPcm+",
	"Zv/K0DFMpVMT7izZIknEZ6bwWJyiFkP3v8OK24xGU8fH575NM4Sq+j32dhlMPoFCIGJvHuJ3FsZnbyMC",
	"e5IGEtzq6ncOIBuYnHBzscgDoXLnGNAB4aq8gxShJDOL2eII5a74vU+ZhVbVaFquLZoJwuJFs6H1l4yN",
	"ev5gsyTGM5Pv/x3pnLNpj3TmV8Ohvp3Zh3yJLVflasV7FvPFfH43X83mE+2TKqIjOSttRJ9xQkqa/Hno",
	"9zZJ5oN8NG+VKBeT9PfIaw0zOErrHxkz4M+mMps7G3GGla9L9iaoSTNviJHEazK4iao5shBIRDQb0i2X",
	"Db/sTlV8fxPsJJ2pILgqPqQUzZe8wDFAS5LljGa2+EVQAZ2kT3NYUJOmw1c09eOVunN6aaxVWj3K5Wzn",
	"g1o1xtInDU38zVMQtbHmJcJY86Vwoy2NP7rTGtPPCE1V+NgiZ2ojI4MHTYADp9SPh6v4ian8DiQDPzno",
	"N/A66GyZhTdY0iZeg8lWBIEesqiLODBW5rR6Pgu9+EoZkLI7ZAhwZFFiQ5MdHTHnIvJ0287edo4ytff6",
	"sS8bzXeem3CEn/L6oLGk7P2R8JITIiLRJlVXbzoqPVO5rzkS6dC/16cM9JGwhlJ5M6NkQVMKMsh4Gv7l",
	"M+dfSnNAItDk012iFddYKqYyM5gYbaV0LPF564CwhPA0SORYCKu0EWhKLIHfzF7vgXxxJ1/uFW24g3Yr",
	"5Z5dKvdqvVoR1koVVIHVql3s7eT7ffgprcOYegwSa5hx8AgBFtZ7mI3HhsiZJZNL2fLTnOdtsUXy5dhf",
	"DOvfoJtJPVkdTneABGKuUmEnQ2RQo915sVfmXEjgADHwmwWJ7SAPk08A24gILKb6SU99vlR0AlRqw0J5",
	"VNCghPsuYsCSh0vVpJhPuIUcWA6WpBlvM0SkS8KzFJ4DKUQFB2tJ9dXNYz7nI5gXCGFotmLRwpl8ey25",
	"1pLKpJjLSM2QSJtLS2D/qnH9N6xxnbwNicrWkvt/zWKWg5OejboKshVQcZW8ibbWzr6nXxKdBo+n/bBK",
	"M4Gx0iQTCRoIE1lwhB0EBg7t9UzgSmjhSncJGmTBR5WDy4eZ//k4x92F6ycW2l36wNul8RSGD7ytgCt4",
	"IrDnQDLSFcF0pZVI7mQwTOy9QHCPHdtSL+kpuSdYjllNOVsoZBeWUsqW4Pc7Hs1+HYRZHgk+pcSjoDQN",
	"gd1lWSOrq08jjy4Z18EWMolmS1XsVTpqwrutrhQtE78l3z+xY7ABXpP0Qp1Ltwrl3+PlTqaT2BORi8Hb",
	"kEAlP2cEpQ5/91GJFuLc8Kyogjrcd1eQVUBHQVPgc0nU9fPjy72TevtE2dDjdbeHsFjZ2asUK9VazUYl",
	"2y6Xy7tVq1i1y4VqsbJTK+3s9Ir5Ui0Pd3o71Xy1n4eF3Wq+XC2hsi3/sQPL/cS8h6Wn8/tOIB64dmXZ",
	"J+3aWMFu33M+jbF+7TGV2+s7ntYy3hXECTlKzmXYN1+UsjDLOzWuo5koujIldrri8TCVsqntJsbjJhhC",
	"gS6hassvsVQ9mQArda2vND/Np9IGq02klzmELtMLVaGpjZTDsGXSdCpVfUl2tU36T57Kv+YbZJG3IAnz",
	"tbkZcv4BbKNzbDZaMMa3ZWDP50Msi/lYm6q/aqKrdfPos/MUPOqx2rUUWuGTJ9vswMZsN9kuqQe1R1UJ",
	"Ci1hfDS10z6mwcdZOS31lynj9RHM1qFCM7ukh2YqgRJIVDELPaKrhYt4nB1ltg7f9BiykK3UZayrd2gP",
	"PeQqUF+qgT06ToykjxR5+/Nqu21dy22zxL6BNzDlGePP/M84UajoLtFtZ3Xe5oLSro7BCE3DmhzyCpi5",
	"/5XqFFfNY7deJhO+CHB1fAWubvfPmw1wdvgA9s8vG2fqc5d0iXvdvNg/rltti+4f1g/O+7WHkxF6O92B",
	"ttN6mFTh8XHTOYWOqJ0+F19z+8Wzz8Nmv+m/Hgvv7rmKuuT8ZnBwW915hp2Kd3dQcY9apyVvhAi6yVkd",
	"9+XlenQxvebDL0V6/WVy+Hbb7hUaF61Gv3E8GH2pXRe75O1xxJpWgx3lr4sTdtZzoG8Pbz/jO0jqB9wt",
	"1B4OX3ivUr8tVW1xy1ql6wf7frB78/kLvurf1W665Gz/uZMvje/2L+1Wmz+Uds9hg+w0vcLl2Ks1D2mu",
	"iQ7vHgovbuPyqg7P8r3Tk5LfH5QbPhrxz512l0yu7zuocf7qP57vXLa+0Murs8m4dd1/7Q0KXw5qY/8x",
	"fyaec9bFSfEV+vlXl9f93ZNTD43Gl1c3r06XTF/E8/Sxz+gdRkdTb/I4GF9PBCGtWm7QPvRzp3cd9pCv",
	"FN3D2061YfWq5ZF1ctQ56rdGDhkd57ok378t129gJV8+Kb0+50eih0rjM+vqC7269M/27/hJe5zP3x4/",
	"1KdXyJ9+rlWt29zD4bBVHZXad2fPXbKDmo+DKW5d5idO4eH44ObM8p3JiO/WP/vOaFCgnV6Zl97cx/FV",
	"vnpMO6/35eIzPKvctz9fDB8R6pLaTv4LvRv2rMKZ1/783H+kz5wdisfaVe/28fPD+Kh24zH7vs6eT3qn",
	"o+Kpd3NWf+0MX/l1ne8Pjwtdkj/3X4v3sLWfHxSblSurZZ/mrJdnmq9ZFnve/+Lj13uGK9jfbX3xai+d",
	"XL/9duFyuzkgtdzL41mX4Nq17/T9atV/Gd7nJqLYEwSLwQ1/eR6+tvznh9vyY688HImj2vDsNvflS7Vc",
	"fBmeV84m9Zv6dX2/S8TB0fHj/c3Ycg8HZwetwlm7Xnt070a90unwvNMqnH/Zn8L7wtAiTj343To5HUP3",
	"7tluVMZdYrnWZ3x9erm/39pv1OvlI3x4iE52XDY8Oqn6d/z6vNUq5h8q1uOQvD7UjuquoqHG8aR21JiM",
	"ml2yP2keH13T00adN/b3Hxr1yWHjZHDYOCrX643B6HrW+/PFQz1X3X/wBs60XX98OBk+T8+GXZL73N95",
	"u+rfjXsnxfzhS2nUrF4e7V/kyfmXz/u3Bdcftz+/dPx26f6c7Zfc0rHvCO/s5vD07Fy4lcODLimw47cv",
	"ddopTL3dh2btvH5gtxqNy+lz/ZnT+9ta9eHWb3zO9cgz66Cb4vnNZaM/vWpUd+53axV8edclbqX9ucev",
	"DybVRvGcOXa9VW4d+HT6WGhjcQwfy2fX53fic+cQFsqYP7SPG89vtHr1ULsrnV6OKvkuGbzcD2rFi1zP",
	"LR6+taudWun+8KBXcMbP5aYzfh00X87QoFB4+/Lw6rKH9uPpaaM/fut/di7aO/7r4KRLnl9zp/mp81g8",
	"x71jtnNcr08vd2/vWf2xPWm38ofWc6c2OWyQ11H7wJ++uPeTu/HF/hf/sHlXu0Slhy5p4dtC//Sixu3q",
	"gcePXiutz19s0iLX7c8n7LlzdXZQcu+ZU7fJYWdoP9zVnh9H3v3wYMpLud1ddNklw1GenZNp/vliMoJ+",
	"P4dva5fWzpdxa/R8ftM6HVRud+/Opqf+/b14m3whz62Lyv3N0f7LWZk/UrfV6pK+6HVOCp8r097Nfa5e",
	"Gu/34OvNfVFUb98unq03NGo/HmJ4frF7njuxThvNm8L1UW2nVjyw687h0a7dJaPi4Bo/tK/rEJ7mT0/r",
	"byfjm9HN6fn54Kz4cP2ATy7upkVROp0e9TmDbmXSbtxf9odXqDk93+88nnbJmHkXzlUP9Xlnt1Lt9Iv7",
	"F01/8PbIGpW714P22ehxcDMs3B2P281r0pi+ja6nO4e3xZcrD99XdiWPGl41vzyyM2qdlc7O27s5/HZ6",
	"3blxxHOr/nuX/H7V71TVuzL6ZZkVV8+SCnSUoSfOneRL+lcd0/Wvn610FPyo19CiBbkS7XFyvEBV11W7",
	"lLslIhVBLgUaDpTKFcnXUcXAuuS3IE7sU2JhsIWMjaBwNN2y+N2P9bDEnShgiQ9lw8IP5vXk7fTqRFGy",
	"btuhCzewxpt3zqAvhpThN2QrfWaxesBGz5bV2/dYjC5Pyre1avnQ5vu3ZCp6pd5kfDMYnDjXTu/hi1Ml",
	"hfx4d0nl6sQiBLf6sbdQ/dFZaOYVanmk4vYr28VkfTw9VyEbEk9J2nEbSXo0Jiz+58XXf08BsOUltery",
	"eCstzdAgga52snO1Pom7LGhruzEH/wMmoUFZRfCq5mnQ84XKm5LEa2xCfC7cej2B/eQqZSES1hcpm9/b",
	"7UuVafO3etJO4xUTzaQl8auXBg4ujrasWRaY1N9VsmzjcgY/oCwB6E0jb+EllGkPyurayRcoaeouhR9S",
	"r2AtNKSvIjn51sC4kI82hUW2XQuJruCwLVYSr4aouWzRULhBwUo9QtQWpu9CCzFhb9FZNl9lTVtiJlyk",
	"OUZtP0wjXFm+eq5E5HdaHBeGWQ79/EIXHRq+oE/maQY458tafcXP78Jewptq+h0oj/ItRo151eaAtQQe",
	"6xpqRliIJXpyZDEkMvr10lACDV8LTap4CTl6SrTnLZrzNpBqg7CC2HDLqj9RNoAkYqiNRp6W86ViOTmq",
	"xlov8oUep74DB0FJBza0dJERHQgRKesVVGGADqemBrFhUBw0zYrmhNZla4rXOYu+mTPb1qyk1Qhi1+J1",
	"7jKJ4S09fyZiMEQ2OLI5SZdQJ1JIdov4xKDbmghFIjwN1YpoQiI8EDSKqQf5LKFMDDPQRQxbMOtR6mSJ",
	"8KR6lkqnCqs+b6VPRIvpLo9SCFqlgwtDXSK3nUZMoL1t5w6hPGdks1jvRX8cmW78uup8HuHaPu3Sdl0W",
	"qr6snePNZ2i7LkueM1rXLSEceF2XhTjQdR2WuU2/fU3mPIHKrN+iW0yyVNVNMAd8SH3HBgypoKueqkp+",
	"2Vei++Im6ZxVFTsrVJJcwt5ngRrXRZCY+E7oOCChIdAnj3cJZEgzPq0SL8wLw7aGS44xVZEu2qUkAe4S",
	"5jtI1yhnqE8ZSoMJAkM4DuvpqNMMVA6fXF0PATiBQRlBLADm5KPoEo9yjnu6KKKLX1V4oQuFNdS+LbMf",
	"QNCBUuQlUw5pZ5nrNZKLu82LxXP5XBuT1IY95us5bEFQG/ZIfgJrY9rYsP0SB/gWVBt9v3j7lL0w6W+T",
	"9HaTQ6zz25e95GfCKYJj83XugG2ZpMd8QpZl4sVSmhfO7dYLemf2eXJUydyQX5deXcszCrO8FKbyBYmD",
	"0ew7auGsYTG6kpJEoO94WVN/wDzLkYxCY3vapopI+O5LgpqnPhY2eV9sQf7eyNh2wY7PDlnrAX9utW4n",
	"/gm8qZ+6N+e0+XbTL74cFO2Dylt+v/Oa23ldlX8WTd5ArJBsYDJS/+KTx0FUo24AuIBMRQKLIfiw8yEN",
	"PlQ+qBD7D8Xeh+hj/3J7VIh4l0ACELHY1BPKoGLe+geXkitPcOSFjx4Cwrzup4qQzorRdknYLx48vFxf",
	"2SyKTYnhls+wmLblUdfbvo8g02elp/51FEx3et+RQrNqKYV53S4cVepCqW/flHLTp0kpNrpElKDGyq1K",
	"tekwUZ3CzrOpWMij3sRU3YPWEIGiSq9TCkPoDZlMJlmoPisXhOnLc+fNxuFF+zBTzOazQ+E6WmgV6iBc",
	"tvfV9CaZmgFVCw1AD0eCwvZSxeDZGvlhL1XK5rOFlC5Nq9CUsxxKEM/9ge1vilqSqvUdIx19pXmmqtsH",
	"DKOT50YFiyMRPFWojWswfNbXCD/6tYCIVZ4yZbCcFRlQBXcwJUCxWGTrrPawjHjT1qBE39pX6SfQRUKp",
	"Gv9MeO07KBUSAC8oGKh6gZiosyeGQSzdXvCAanDitNKn2edPeRL/q5xNWzbVZhTz+Uj+j8l9dUy0Su7Z",
	"VGGfAbRSHIhgSR3nOGaiOJFHpPwDpzYp/YuTNokWOs3JANjWUxd+/tR1X1VdHiHl+MEaED176efPfktm",
	"vht5Aj3E5NkA4dnWkJT/DEhGhE7I3BZU/ozdvyXo1dNZJqpMBKCWekzMjrFwRcUB8/7nV0kjYbS3KpIR",
	"ZUKKeYXnSY2TC/5Q9ZKT3nNt6EJhEBA0CbqmgUfl0nGQDsNNUVJlOx4jBgPmrvi9UfHUg+baR4dZVOHj",
	"i4zrinJheHUqfNR/n9rTH0fx8bf9v8WvT8nMvi3wm8KPnr1pJ229+agq4yjxA9l/GdNhswf3f3GeX5xn",
	"Q85jmEYSp/lRwtMW8lKAwzWCUrTOzmaiUjjwf5mwFMNUwgmK4+WXwPSLbf1NBaal/EsrglGpKUF+kU1m",
	"QswG/CTCrP6NuMhPkL0imFED/9nSV2T+MFgm4UipCoZoMiu13FOF/nSp2yUymUCvIqfsOHF45lG7Mfcq",
	"/6gJkmjzW+zWlmiJPTKwggAcU97ne27xPiaYDyOXOFh5h2Mxu7rTSqNQLhkXCRgLU4I96guTo8J9R6y6",
	"5lV1ol+X/NpLXuFpCWnIIxC+BaG9eaGCiAkgVL8zbPkOZKYCJPhNDKk/GBp/2mn78uJT9j+OkI7VQweD",
	"wNEZnPIkMnIhwX3ExXpaCltuQE43SPiMcJVEF/RTwCgd3LAzYkhF8XdTCzdsbFFFWGGVOLN9QS1gKEDU",
	"HGtKu+qQdEhy5u9MMFy2soIUWyEKftHjWnqcIWsJUca2e4Ew/zNpLU4eGxBdJIF/Nc2FFZ0kyS3QmX6G",
	"Bb1CS8QuIqbID9nARrroIo3RWmj6V0W0V1FGAOcvwlhPGOEDyUvoItjKbejil5L6S0n9d1NSF3jTen7H",
	"e9RdLmAEwgIEOnYqXkybr5EbumSuOWRhG1V3e1b6e6nJbf+yteXlL2HSAVeazYFgjP8S05ta7RJOpz7+",
	"t13/s0XPk4JtHvDPzV79X2m2CR783w+b/xwjSDDPVh6o/E+Yfrn9I2gzywpycOAL+hOvymAHfzmjFi/M",
	"v8utFRwlXdeF6YjVkCJ1gF1ODR69qBZujNkT+AvXRdLKZk1yqpDyssDLSDtVafmn8vDZGpKOXPgYrEHG",
	"r7P+1wiH+qD//UTD2WvC0HFAGDIenKYZma33w0ISlkgNvBMaslmt1d4UKBkomVA393og0/xd4lvpTxbG",
	"lm6l+gCiv/2i4l9UvA0Vo8UTJCk3DE1dfkNemibvPPfzUcMLCzWgKF4g9T05hNH1/o7a9MrlSNTr8gK5",
	"aAb9ch0ino//kxSI5IIOf7IasaTyQMJm6ZYggERH1Ad6hT0rFfCnqhY8AOqXYvE3VSzaYdkPc4iQHbPF",
	"UxIRiWJFQzRAYebtgnTSMq8/q/R99WR5+CxOPCEBejir6mwPcV8ng0MP5/TzW8oPhlgmeHo+Ny4qLWSO",
	"NgQcYDJYNQEXcIDeOY2ln8Uzr1OH06wb5+u3/x8AAP//0GyYT0PaAAA=",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
